"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _ReactRxBingMapContainer = require("./ReactRxBingMapContainer");

var _ReactRxBingMapContainer2 = _interopRequireDefault(_ReactRxBingMapContainer);

var BingMap = (function (_Component) {
  _inherits(BingMap, _Component);

  function BingMap() {
    _classCallCheck(this, BingMap);

    _get(Object.getPrototypeOf(BingMap.prototype), "constructor", this).apply(this, arguments);

    this.state = {};
  }

  _createClass(BingMap, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var domElement = _react2["default"].findDOMNode(this);
      var _props = this.props;
      var children = _props.children;

      var mapProps = _objectWithoutProperties(_props, ["children"]);

      // TODO: support asynchronous load of bing.maps API at this level.
      //
      // Create  BING Map instance so that dom is initialized before
      // React's children creators.
      //
      var map = _ReactRxBingMapContainer2["default"]._createMap(domElement, mapProps);
      this.setState({ map: map });
    }
  }, {
    key: "clearMap",
    value: function clearMap() {
      this.state.map.clearEntities();
    }
  }, {
    key: "render",
    value: function render() {
      var containerTagName = "div";
      var _props2 = this.props;
      var domProps = _props2.domProps;
      var children = _props2.children;

      var mapProps = _objectWithoutProperties(_props2, ["domProps", "children"]);

      var mapComponent = this.state.map;
      if (mapComponent) mapComponent.clearEntities();

      if (this.props.initialMapViews && mapComponent) {
        mapComponent.setupMapMovementObservable(this.props.initialMapViews);
      }

      var child = this.state.map ? _react2["default"].createElement(
        _ReactRxBingMapContainer2["default"],
        _extends({ map: mapComponent }, mapProps),
        children
      ) : undefined;

      return _react2["default"].createElement(containerTagName, domProps, child);
    }
  }], [{
    key: "propTypes",
    value: {
      BingTheme: _react.PropTypes.bool,
      CenterMap: _react.PropTypes.bool,
      ShowTraffic: _react.PropTypes.bool,
      credentials: _react.PropTypes.string.isRequired
    },
    enumerable: true
  }]);

  return BingMap;
})(_react.Component);

exports["default"] = BingMap;
module.exports = exports["default"];